import aggregate from "./aggregate";
import chunk from "./chunk";
import difference from "./difference";
import intersection from "./intersection";
import mapify from "./mapify";
import nth from "./nth";
import orm from "./orm";
import range from "./range";
import remove from "./remove";
import shuffle from "./shuffle";
import sort from "./sort";
import unique from "./unique";
declare const autil: {
    aggregate: <T, K extends PropertyKey>(array: T[], key: (value: T) => K) => Map<K, T[]>;
    chunk: <T_1>(array: T_1[], size: number) => T_1[][];
    difference: <T_2>(array: T_2[], values_0: T_2[], ...values_1: T_2[][]) => T_2[];
    intersection: <T_3>(array: T_3[], values_0: T_3[], ...values_1: T_3[][]) => T_3[];
    mapify: <T_4>(array: T_4[], key: (value: T_4) => string) => Map<string, T_4>;
    nth: <T_5>(array: T_5[], index: number) => T_5;
    orm: <T_6>(array: T_6[]) => import("./orm").ORMArray<T_6>;
    range: (min: number, max?: number | undefined, step?: number | undefined) => number[];
    remove: <T_7>(array: T_7[], indices_0: number, ...indices_1: number[]) => T_7[];
    shuffle: <T_8>(array: T_8[], copy?: boolean | "deep" | "shallow" | undefined) => T_8[];
    sort: <T_9>(array: T_9[], opts?: {
        by?: import("./utils/sort").DeepKeyof<T_9, "", Exclude<keyof T_9, number | keyof unknown[]>> | undefined;
        type?: "number" | "boolean" | "string.length" | "alphabetically" | undefined;
        order?: 1 | -1 | "asc" | "desc" | "ASC" | "DESC" | "ascending" | "descending" | "ASCENDING" | "DESCENDING" | undefined;
        copy?: boolean | "deep" | "shallow" | undefined;
    } | ((a: T_9, b: T_9) => number) | undefined) => T_9[];
    unique: <T_10>(array: T_10[], deep?: boolean | undefined) => T_10[];
};
export { aggregate, chunk, difference, intersection, mapify, nth, orm, range, remove, shuffle, sort, unique };
export default autil;
