declare type KeysToValues<A, T> = A extends readonly [infer Key, ...infer Rest] ? readonly [T[Key & keyof T], ...KeysToValues<Rest, T>] : readonly [];
export declare class ORMArray<T> extends Array<T> {
    #private;
    constructor(items: T[], parent: T[]);
    select<C extends "*" | readonly (keyof T)[]>(columns: C): ORMArray<C extends "*" ? T : Pick<T, (C & (keyof T)[])[number]>>;
    where(): void;
    update<C extends readonly (keyof T)[], V extends KeysToValues<C, T>>(columns: C, values: V): ORMArray<T>;
    delete<C extends "*" | readonly (keyof T)[]>(columns: C): Array<C extends "*" ? T : Pick<T, (C & (keyof T)[])[number]>>;
}
declare const orm: <T>(array: T[]) => ORMArray<T>;
export default orm;
