"use strict";
var _ORMArray_parent, _ORMArray_target;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ORMArray = void 0;
const tslib_1 = require("tslib");
const clone_1 = tslib_1.__importDefault(require("./utils/clone"));
class ORMArray extends Array {
    constructor(items, parent) {
        super();
        _ORMArray_parent.set(this, void 0);
        _ORMArray_target.set(this, void 0);
        if (Array.isArray(items))
            items.forEach((item, i) => (this[i] = item));
        tslib_1.__classPrivateFieldSet(this, _ORMArray_parent, parent, "f");
    }
    select(columns) {
        if (columns === "*")
            return new ORMArray(clone_1.default(this), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
        return new ORMArray(clone_1.default(this.map((item) => Object.fromEntries(Object.entries(item).filter(([key]) => columns.includes(key))))), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
    }
    where() { }
    update(columns, values) {
        if (!tslib_1.__classPrivateFieldGet(this, _ORMArray_target, "f")) {
            tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f").forEach((item) => {
                columns.forEach((col, i) => (item[col] = values[i]));
            });
            return new ORMArray(tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
        }
        tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f").forEach((item, i) => {
            if (tslib_1.__classPrivateFieldGet(this, _ORMArray_target, "f").includes(item))
                columns.forEach((col, i) => (item[col] = values[i]));
        });
        return new ORMArray(tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
    }
    delete(columns) {
        if (columns === "*") {
            if (!tslib_1.__classPrivateFieldGet(this, _ORMArray_target, "f"))
                return [];
            tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f").forEach((item, i) => {
                if (tslib_1.__classPrivateFieldGet(this, _ORMArray_target, "f").includes(item))
                    tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f").splice(i, 1);
            });
            return new ORMArray(tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
        }
        if (!tslib_1.__classPrivateFieldGet(this, _ORMArray_target, "f")) {
            tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f").forEach((item) => {
                for (const key of columns)
                    delete item[key];
            });
            return new ORMArray(tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
        }
        tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f").forEach((item, i) => {
            if (tslib_1.__classPrivateFieldGet(this, _ORMArray_target, "f").includes(item))
                for (const key of columns)
                    delete item[key];
        });
        return new ORMArray(tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"), tslib_1.__classPrivateFieldGet(this, _ORMArray_parent, "f"));
    }
}
exports.ORMArray = ORMArray;
_ORMArray_parent = new WeakMap(), _ORMArray_target = new WeakMap();
const orm = (array) => new ORMArray(array, array);
exports.default = orm;
