"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function clone(object) {
    if (typeof object == "function")
        return object;
    const result = (Array.isArray(object) ? [] : {});
    Object.entries(object).forEach(([key, value]) => {
        if (Array.isArray(value))
            result[key] = clone(value);
        else if (value instanceof Date)
            result[key] = new Date(value.getTime());
        else if (value instanceof RegExp)
            result[key] = RegExp(value.source, value.flags);
        else if (typeof value === "object" && value)
            result[key] = clone(value);
        else
            result[key] = value;
    });
    return result;
}
exports.default = clone;
