import { DeepKeyof } from "./sort";
declare type Split<Input extends string, Separator extends string = ""> = Input extends "" ? [] : Input extends `${infer Start}${Separator}${infer End}` ? [Start, ...Split<End, Separator>] : [Input];
declare type Join<A extends ReadonlyArray<unknown>, Sep extends string = ""> = A extends readonly [infer Head, ...infer Rest] ? Join<Rest, Sep> extends "" ? `${Head & (string | number | bigint | boolean)}` : `${Head & (string | number | bigint | boolean)}${Sep}${Join<Rest, Sep>}` : "";
declare type DeepGet<T extends object, K extends DeepKeyof<T>> = Split<K, "."> extends [infer Key, ...infer Rest] ? Rest extends [] ? T[Key & keyof T] : T[Key & keyof T] extends object ? DeepGet<T[Key & keyof T], Join<Rest, "."> & DeepKeyof<T[Key & keyof T]>> : never : never;
export default function get<T extends object, K extends DeepKeyof<T>>(o: T, k: K): DeepGet<T, K> | undefined;
export {};
